#include "imgproc.h"

class CHeapImageFactory : public IImageFactory
{
public:
	STDMETHODIMP QueryInterface(REFIID riid, LPVOID* ppv)
	{
		if(riid == IID_IImageFactory)
			*ppv = static_cast<IImageFactory*>(this);
		else if(riid == IID_IUnknown)
			*ppv = static_cast<IUnknown*>(this);
		else
			return E_NOINTERFACE;
		return S_OK;
	}

	STDMETHODIMP_(ULONG) AddRef()
	{
		return 1;
	}

	STDMETHODIMP_(ULONG) Release()
	{
		return 1;
	}

	STDMETHODIMP CreateImage(DWORD dwCX, DWORD dwCY, PixelFormat* pFormat, IImage** ppimgOut)
	{
		IMalloc* pMalloc;
		HRESULT hr = ::CoGetMalloc(1, &pMalloc);
		if(FAILED(hr))
			return hr;
		hr = CoCreateImage(pMalloc, dwCX, dwCY, pFormat, IID_IImage, (void**)ppimgOut);
		pMalloc->Release();
		return hr;
	}

} g_HeapImageFactory;

IImageFactory* __stdcall GetHeapImageFactory()
{
	IImageFactory* pif;
	HRESULT hr = g_HeapImageFactory.QueryInterface(IID_IImageFactory, (void**)&pif);
	return SUCCEEDED(hr) ? pif : NULL;
}
