/**
 *  objtmpl.h - COM Object Templates
 *  Author:  J. M. Rowlett (rowlett@andrew)
 *  Created:  9/4/99
 **/

#ifndef __OBJTMPL_H__
#define __OBJTMPL_H__

template<class T>
class TCOMObject : public T
{
public:
	TCOMObject() : m_dwRefCount(0) {}

	STDMETHODIMP_(ULONG) AddRef()
	{
		return InterlockedIncrement((LONG*)&m_dwRefCount);
	}

	STDMETHODIMP_(ULONG) Release()
	{
		DWORD dw = InterlockedDecrement((LONG*)&m_dwRefCount);
		if(dw == 0)
		{
			delete this;
			return 0;
		}
		return dw;
	}

private:
	DWORD m_dwRefCount;
};

#define ADDREF(x) reinterpret_cast<IUnknown*>(x)->AddRef
#define RELEASE(x) reinterpret_cast<IUnknown*>(x)->Release

#define NULLIFY(x) x->Release(); x = NULL;

#endif /* __OBJTMPL_H__ */